#define WIN32_LEAN_AND_MEAN

#include "Chapt1.h"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

//#define GLIDE_DRAWING

int iii=0;

bool EnableZBuffer=false;
bool TripleBuffering=false;

float ScreenWidth=640;
float ScreenHeight=480;
GrScreenResolution_t grRes=GR_RESOLUTION_640x480;

WORD *FrontBuffer;
DWORD *FrontBuffer32;

float LODBias=0;

float Gamma;

bool Pause;

FxI32 GammaEntries;

bool PaletteMode;

FxU32 *PaletteRed;
FxU32 *PaletteGreen;
FxU32 *PaletteBlue;

FxU32 *CurrentRed;
FxU32 *CurrentGreen;
FxU32 *CurrentBlue;

#define TypeConv(A) ((float)(short)(A))

#define PG_VTX_X(I) TypeConv(Buf[curadr+4+2*(I)])
#define PG_VTX_Y(I) TypeConv(Buf[curadr+5+2*(I)])
#define PG_VTX(I) PG_VTX_X(I),PG_VTX_Y(I)

#define grGetGammaTable ((void (__stdcall *)(FxU32, FxU32*, FxU32*, FxU32*)) grGetProcAddress("grGetGammaTableExt"))

float MonitorWeariness=0;
int GammaState=0;

float z0=0;

HDC ScreenDC;
HBITMAP VRam;
BYTE *VData;
BITMAPINFO VAttr;
HWND hWnd;

//char FileName[1024]="E:\\Alexandr\\ \\Metafile\\Metaedit\\WMF\\prntout2.wmf";
char FileName[1024]="C:\\Temp\\XP\\3Dfx\\WMF\\disk35.wmf";

BYTE BitmapHeader[54]={0x42,0x4D,0x36,0,0x24,0,0,0,0,0,0x36,0,0,0,0x28,0,0,0,0x20,3,0,0,0x58,2,0,0,1,0,0x18,0,0,0,0,0,0,0,0x24,0,0xC4,0xE,0,0,0xC4,0xE,0,0,0,0,0,0,0,0,0,0};
BYTE *BitmapData;

DWORD WINAPI Drawing(LPVOID);

int InStr(int start,const char *s,char symbol) {
	int i,l=strlen(s);
	for (i=start;i<l;i++)
		if (symbol==s[i]) return i;
	return -1;
}

int InStr(int start,const char *s,const char *s2) {
	int i,j,l,l2;
	bool b;
	l=strlen(s);
	l2=strlen(s2);
	if ((l<l2)||(l2<=0)) return -1;
	for (i=0;i<=l-l2;i++)
		if (s[i]==s2[0]) {
			b=true;
			for (j=1;j<l2;j++) b=b&&(s[i+j]==s2[j]);
			if (b) return i;
		}
	return -1;
}

int sign(float x) {
	return (x==0)?0:(x/fabs(x));
}

int Orientation (float x1,float y1,float x2,float y2,float x3,float y3) {
	return sign((x2-x1)*(y3-y2)-(y2-y1)*(x3-x2));
}

#define MIN(a,b) ((a<b)?a:b)
#define MAX(a,b) ((a>b)?a:b)
#define IN_INTERVAL(a,a1,a2) ((a>=MIN(a1,a2))&&(a<=MAX(a1,a2)))

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

	if (strlen(lpCmdLine)) {
		strcpy(FileName,lpCmdLine+((lpCmdLine[0]==34)?1:0));
		if (FileName[strlen(FileName)-1]==34) FileName[strlen(FileName)-1]=0;
	}
	char CurDir[1024];
	strcpy(CurDir,GetCommandLine());
	CurDir[InStr(0,CurDir,"GlideMaster.exe")]=0;
	if (CurDir[0]==34)
		SetCurrentDirectory(CurDir+1);
	else
		SetCurrentDirectory(CurDir);

	Start(0);

	return 0;

}

//---------------------------------------------------------------------------

// "" 3DFX
bool Start(HWND hWnd)
{//      3dfx
	if (!grGet(GR_NUM_BOARDS, sizeof(Num3Dfx), &Num3Dfx)) return false;
	char ScrMode[16];
	char Buffering[16];
	int BoardNumber=0;
	FILE *devcfg=fopen("GlideDevice.cfg","rt");
	if (devcfg) {
		fscanf(devcfg,"%i",&BoardNumber);
		fscanf(devcfg,"%s",ScrMode);
		fscanf(devcfg,"%s",Buffering);
		fclose(devcfg);	
		if (strlen(ScrMode)>=7) {
			if (!strcmp(ScrMode,"320x240")) {grRes=GR_RESOLUTION_320x240; ScreenWidth=320; ScreenHeight=240;}
			if (!strcmp(ScrMode,"400x300")) {grRes=GR_RESOLUTION_400x300; ScreenWidth=400; ScreenHeight=300;}
			if (!strcmp(ScrMode,"512x384")) {grRes=GR_RESOLUTION_512x384; ScreenWidth=512; ScreenHeight=384;}
			if (!strcmp(ScrMode,"640x480")) {grRes=GR_RESOLUTION_640x480; ScreenWidth=640; ScreenHeight=480;}
			if (!strcmp(ScrMode,"800x600")) {grRes=GR_RESOLUTION_800x600; ScreenWidth=800; ScreenHeight=600;}
			if (!strcmp(ScrMode,"960x720")) {grRes=GR_RESOLUTION_960x720; ScreenWidth=960; ScreenHeight=720;}
			if (!strcmp(ScrMode,"1024x768")) {grRes=GR_RESOLUTION_1024x768; ScreenWidth=1024; ScreenHeight=768;}
			if (!strcmp(ScrMode,"1600x1200")) {grRes=GR_RESOLUTION_1600x1200; ScreenWidth=1600; ScreenHeight=1200;}
			if (!strcmp(ScrMode,"320x200")) {grRes=GR_RESOLUTION_320x200; ScreenWidth=320; ScreenHeight=200;}
			if (!strcmp(ScrMode,"400x256")) {grRes=GR_RESOLUTION_400x256; ScreenWidth=400; ScreenHeight=256;}
			if (!strcmp(ScrMode,"512x256")) {grRes=GR_RESOLUTION_512x256; ScreenWidth=512; ScreenHeight=256;}
			if (!strcmp(ScrMode,"640x200")) {grRes=GR_RESOLUTION_640x200; ScreenWidth=640; ScreenHeight=200;}
			if (!strcmp(ScrMode,"640x350")) {grRes=GR_RESOLUTION_640x350; ScreenWidth=640; ScreenHeight=350;}
			if (!strcmp(ScrMode,"640x400")) {grRes=GR_RESOLUTION_640x400; ScreenWidth=640; ScreenHeight=400;}
			if (!strcmp(ScrMode,"856x480")) {grRes=GR_RESOLUTION_856x480; ScreenWidth=856; ScreenHeight=480;}
			if (!strcmp(ScrMode,"1280x1024")) {grRes=GR_RESOLUTION_1280x1024; ScreenWidth=1280; ScreenHeight=1024;}
			if (!strcmp(ScrMode,"1152x864")) {grRes=16; ScreenWidth=1152; ScreenHeight=864;}
		}
	}
	/*if (!LoadWMF(FileName)) {
		MessageBox(hWnd,"Can't load metafile","Glide WMF",MB_ICONERROR);
		return false;
	}
	if ((BoardNumber<0)||(BoardNumber>Num3Dfx-1)) {
		MessageBox(hWnd,"Wrong device number (GlideDevice.cfg)","Glide WMF",MB_ICONERROR);
		return false;
	}
	TripleBuffering=(Buffering[0]=='T')||(Buffering[0]=='t');*/
	grGlideInit();
	grSstSelect(BoardNumber);
	#ifdef GLIDE_DRAWING
		
		//grRes=16;
		//ScreenWidth=1152; ScreenHeight=864;
		Context = grSstWinOpen((FxU32)GetForegroundWindow(),             //  
								grRes,					// 
								GR_REFRESH_85Hz,        //  
								GR_COLORFORMAT_ABGR,    //  
								GR_ORIGIN_UPPER_LEFT,	//   (0,0)
								TripleBuffering?3:2,    //  
								EnableZBuffer?1:0);     //    Z-

		if (Context == NULL) {
			MessageBox(hWnd,"Can't set video mode (GlideDevice.cfg)","Glide WMF",MB_ICONERROR);
			return false;
		}

	#endif

	grGet(GR_GAMMA_TABLE_ENTRIES,4,&GammaEntries);
	PaletteRed=new FxU32 [GammaEntries];
	PaletteGreen=new FxU32 [GammaEntries];
	PaletteBlue=new FxU32 [GammaEntries];
	CurrentRed=new FxU32 [GammaEntries];
	CurrentGreen=new FxU32 [GammaEntries];
	CurrentBlue=new FxU32 [GammaEntries];

	if (!Drawing(0)) return false;
	return true;
}

// 
void ShutDown()
{
	#ifdef GLIDE_DRAWING
		grSstWinClose(Context);	
	#endif
	
}

bool GetGamma() {
	FxU32 *r,*g,*b;
	bool *ch;
	r=new FxU32 [GammaEntries];
	g=new FxU32 [GammaEntries];
	b=new FxU32 [GammaEntries];
	ch=new bool [GammaEntries];
	grGetGammaTable(GammaEntries,r,g,b);
	bool c=false,p=false;
	int i;
	for (i=0;i<GammaEntries;i++)
		c=c||(ch[i]=(r[i]!=CurrentRed[i])||(g[i]!=CurrentGreen[i])||(b[i]!=CurrentBlue[i]));
	if (c) {
		for (i=1;i<GammaEntries;i++)
			p=p||(r[i]<r[i-1])||(g[i]<g[i-1])||(b[i]<b[i-1]);
		if (p)
			for (i=0;i<GammaEntries;i++)
				if (ch[i]) {
					PaletteRed[i]=r[i];
					PaletteGreen[i]=g[i];
					PaletteBlue[i]=b[i];
				};
		for (i=0;i<GammaEntries;i++) {
			CurrentRed[i]=r[i];
			CurrentGreen[i]=g[i];
			CurrentBlue[i]=b[i];
		};
		PaletteMode=p;
	}
	delete [] r;
	delete [] g;
	delete [] b;
	return c;
}

//float Min(float a,float b) {return (a<=b)?a:b;}
//float Max(float a,float b) {return (a>=b)?a:b;}

float SetGamma(float gamma) {
	//LastUpdateTime=GetTickCount();
	float gm=gamma;
	bool c=false;
	//if (PaletteMode) return gm;
	if (GammaState!=1) {
		if (gm<1./8) gm=1./8;
		if (gm>8) gm=8;
	}
	_try {
		FxU32 *r,*g,*b;
		r=new FxU32 [GammaEntries];
		g=new FxU32 [GammaEntries];
		b=new FxU32 [GammaEntries];
		float f,f0,f1;
		int i;
		f0=abs(MonitorWeariness);
		GetGamma();
		f1=1/gm;
		if (MonitorWeariness<0) {
			for (i=1; i<GammaEntries; i++) {
				f=i/(GammaEntries-1.);
				r[i]=g[i]=b[i]=255*(f0+(1-f0)*pow(f,f1*(0.5+max(0,f-0.5d))));
			};
			r[0]=g[0]=b[0]=0;
		} else {			
			if (PaletteMode) {
				for (i=0; i<GammaEntries; i++) {
					r[i]=255*(f0+(1-f0)*pow(PaletteRed[i]/(GammaEntries-1.),f1));
					g[i]=255*(f0+(1-f0)*pow(PaletteGreen[i]/(GammaEntries-1.),f1));
					b[i]=255*(f0+(1-f0)*pow(PaletteBlue[i]/(GammaEntries-1.),f1));
				}
			} else {
				for (i=1; i<GammaEntries; i++) {
					f=i/(GammaEntries-1.);
					r[i]=g[i]=b[i]=255*(f0+(1-f0)*pow(f,f1));
				};
				r[0]=g[0]=b[0]=0;
			}
		}
		for (i=0;i<GammaEntries;i++)
			c=c||(r[i]!=CurrentRed[i])||(g[i]!=CurrentGreen[i])||(b[i]!=CurrentBlue[i]);
		if (c/*||(gm==0)*/) {
			grLoadGammaTable(GammaEntries,r,g,b);
			for (i=0;i<GammaEntries;i++) {
				CurrentRed[i]=r[i];
				CurrentGreen[i]=g[i];
				CurrentBlue[i]=b[i];
			}
		}
		if (GammaState==2) {
			DWORD dw=4*GammaEntries;
			BYTE *gtv;
			gtv=new BYTE [dw];
			HANDLE hGammaTable;
			hGammaTable=CreateFile("GammaTable.dat",GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
			if (hGammaTable!=INVALID_HANDLE_VALUE) {
				for (i=0;i<GammaEntries;i++) {
					gtv[4*i]=r[i];
					gtv[4*i+1]=g[i];
					gtv[4*i+2]=b[i];
					gtv[4*i+3]=0;
				}
				WriteFile(hGammaTable,gtv,dw,&dw,0);
			}
			CloseHandle(hGammaTable);
			/*FILE *gt=fopen("GammaTable.dat","wt");
			if (gt) {
				fprintf(gt);
				fclose(gt);
			}*/
			delete [] gtv;
			//To gammatable.dat
			GammaState=0;
		}
		delete [] r;
		delete [] g;
		delete [] b;
	} _except (EXCEPTION_EXECUTE_HANDLER) {
		gm=Gamma;
	};
	//guGammaCorrectionRGB(gm,gm,gm);
	return gm;
}

float DefaultGamma() {
	float gm;
	FILE *fg=fopen("GlideColors.cfg","rt");
	if (fg) {
		fscanf(fg,"%f",&gm);
		fscanf(fg,"%f",&MonitorWeariness);
		fclose(fg);
	} else gm=1.2;
	//if (MonitorWeariness<0) MonitorWeariness=0;
	if (MonitorWeariness>0.5) MonitorWeariness=0.5;
	return SetGamma(gm);
}

DWORD WINAPI Drawing(LPVOID)
{

	//SetForegroundWindow(hWnd);

	//Sleep(1000);

	//DestroyWindow(hWnd);

	DWORD BeginTime=GetTickCount();
	DWORD Frames=0;

	DWORD t=GetTickCount();
	DWORD dt=0,dw;

	Gamma=DefaultGamma();

	Pause=false;

	DWORD Interval=0;
	
	POINT mcp;

	FILE *rep=fopen("GlideMaster.rep","wt");
	fprintf(rep,"Vendor: %s\n",grGetString(GR_VENDOR));
	fprintf(rep,"Hardware: %s\n",grGetString(GR_HARDWARE));
	fprintf(rep,"Renderer: %s %s\n",grGetString(GR_RENDERER),grGetString(GR_VERSION));
	fprintf(rep,"Extensions:%s\n",grGetString(GR_EXTENSION));
	fprintf(rep,"%i\n",grGetProcAddress("grGetGammaTableExt"));
	fclose(rep);

	DWORD LastGammaUpdate=GetTickCount();

	bool NCG=true;
	bool NCB=false;

	do {

		#ifdef GLIDE_DRAWING
			grBufferClear( (GammaState==1)?0x000000:BkColor, 0, 0 );
			if (AA) grEnable(GR_AA_ORDERED); else grDisable(GR_AA_ORDERED);   // -
			myVertex vtx1={0,0};
			myVertex vtx2={1024,0};
			myVertex vtx3={1024,768};
			myVertex vtx4={0,768};
			//grDrawTriangle(&vtx1,&vtx2,&vtx3);
			//grDrawTriangle(&vtx3,&vtx4,&vtx1);
			//grConstantColorValue(0xFFFFFFFF);
		#endif

		t+=(dt=GetTickCount()-t*1.);

		float step=1;
		float f;
		int i,j,k;

		if (dt<8) step=dt/8.;
		if (dt>40) step=dt/40.;

		/*if (Frames%10==0) {
			SetActiveWindow(hWnd);
			SetForegroundWindow(hWnd);
			Sleep(100);
		}*/

		GetAsyncKeyState(8);
		GetAsyncKeyState(19);
		GetAsyncKeyState(45);
		/*for (i=33;i<=37;i++)
			GetAsyncKeyState(i);*/

		bool CtrlAlt=GetAsyncKeyState(17)&&GetAsyncKeyState(18);
		bool Shift=GetAsyncKeyState(16);

		//if (1&GetAsyncKeyState(19)) Pause=!Pause;
		if (CtrlAlt)
			for (int i=0;i<10;i++) {
				if (GetAsyncKeyState(48+i))
					if (Shift) {
						
					} else {
						Interval=i?(10000/(i*i)):0;
					};
			}

		if (Interval)
			if (GetTickCount()-LastGammaUpdate>=Interval) {
				Gamma=SetGamma(Gamma);
				LastGammaUpdate=GetTickCount();
				//MessageBox(0,"","",0);
			}
		
		{
			f=pow(1.01,step);
			if (CtrlAlt&&GetAsyncKeyState(45)) {
				if (!GammaState) {
					GammaState=1;
					SetGamma(1e-10);
				}
			} else if (GetAsyncKeyState(VK_CAPITAL)) {
				//guGammaCorrectionRGB(1,1,1);
			} else {
				if (GammaState==1) {
					GammaState=2;
					SetGamma(Gamma);
				}
				if (CtrlAlt) {
					if (GetAsyncKeyState(36)) Gamma=DefaultGamma();
					if (GetAsyncKeyState(35)) {
						FILE *fg=fopen("GlideColors.cfg","wt");
						if (fg) {
							fprintf(fg,"%f\n",Gamma);
							fprintf(fg,"%f",MonitorWeariness);
							fclose(fg);
						}
					}
					//if (GetAsyncKeyState(37)) {LODBias-=0.01; NCB=true;}
					//if (GetAsyncKeyState(39)) {LODBias+=0.01; NCB=true;}
				}
				if (LODBias<-2) LODBias=-2;
				if (LODBias>2) LODBias=2;
				if (NCB) {
					grTexLodBiasValue(GR_TMU0,LODBias);
					NCB=false;
				}
				f=1;
				if (CtrlAlt&&GetAsyncKeyState(33)) {
					if (Shift)
						MonitorWeariness+=0.001;
					else
						f*=pow(1.01,step);
					NCG=true;
				}
				if (CtrlAlt&&GetAsyncKeyState(34)) {
					if (Shift)
						MonitorWeariness-=0.001;
					else
						f/=pow(1.01,step);
					NCG=true;
				}
				if (MonitorWeariness<-1) MonitorWeariness=-1;
				if (MonitorWeariness>1) MonitorWeariness=1;
				if (NCG) {
					Gamma=SetGamma(Gamma*f);
					NCG=false;
					LastGammaUpdate=GetTickCount();
				}
			}
			if (CtrlAlt&&GetAsyncKeyState(8)) {
				Context = grSstWinOpen((FxU32)GetForegroundWindow(),             //  
							grRes,					// 
							GR_REFRESH_85Hz,        //  
							GR_COLORFORMAT_ABGR,    //  
							GR_ORIGIN_UPPER_LEFT,	//   (0,0)
							TripleBuffering?3:2,    //  
							EnableZBuffer?1:0);     //    Z-
				//guGammaCorrectionRGB(2,2,2);
				FxU32 *r,*g,*b;
				r=new FxU32 [GammaEntries];
				g=new FxU32 [GammaEntries];
				b=new FxU32 [GammaEntries];
				float f,f0,f1;
				int i;
				f0=MonitorWeariness;
				f1=1/1.5;
				for (i=1; i<GammaEntries; i++) {
					f=i/(GammaEntries-1.);
					r[i]=g[i]=b[i]=255*(f0+(1-f0)*pow(f,f1));
				};
				r[0]=g[0]=b[0]=0;
				grLoadGammaTable(GammaEntries,r,g,b);
				grCoordinateSpace(GR_WINDOW_COORDS);
				grVertexLayout(GR_PARAM_XY, 0, GR_PARAM_ENABLE);
				grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER,GR_COMBINE_FACTOR_ONE,GR_COMBINE_LOCAL_CONSTANT,GR_COMBINE_OTHER_CONSTANT,FXFALSE);
				int tcdr,tclr,tclr0;
				for (tcdr=0;tcdr<2;tcdr++) {
					grBufferClear(0,0,0);
					for (tclr=0;tclr<256;tclr++) {
						{myVertex vtx1={ScreenWidth/256.*tclr*1.,0};
						myVertex vtx2={ScreenWidth/256.*(tclr+1)*1.,0};
						myVertex vtx3={ScreenWidth/256.*(tclr+1)*1.,ScreenHeight/2};
						myVertex vtx4={ScreenWidth/256.*tclr*1.,ScreenHeight/2};
						grConstantColorValue(0xFF000000+tclr*0x010101);
						grDrawTriangle(&vtx1,&vtx2,&vtx3);
						grDrawTriangle(&vtx3,&vtx4,&vtx1);}
						tclr0=255*(tclr>127);
						{myVertex vtx1={ScreenWidth/256.*tclr*1.,ScreenHeight/2};
						myVertex vtx2={ScreenWidth/256.*(tclr+1)*1.,ScreenHeight/2};
						myVertex vtx3={ScreenWidth/256.*(tclr+1)*1.,ScreenHeight};
						myVertex vtx4={ScreenWidth/256.*tclr*1.,ScreenHeight};
						grConstantColorValue(0xFF000000+(tcdr?(2*tclr-tclr0):tclr0)*0x010101);
						grDrawTriangle(&vtx1,&vtx2,&vtx3);
						grDrawTriangle(&vtx3,&vtx4,&vtx1);}
					}
					grBufferSwap(1);
				}
				do {
					for (tcdr=0;tcdr<16;tcdr++) grBufferSwap(1);
				} while (!GetAsyncKeyState(27));
				if (Context)
					grSstWinClose(Context);
				else
					MessageBox(hWnd,"Can't set video mode (GlideDevice.cfg)","Glide Master",MB_ICONERROR);
			}
			
			//if (CtrlAlt&&GetAsyncKeyState(27)) goto quit;
		}
		Sleep(10);
	} while (true);

quit:
	
	grGlideShutdown();

	DWORD EndTime=GetTickCount();

	DestroyWindow(hWnd);
	PostQuitMessage(0);
	return true;
}