#define WIN32_LEAN_AND_MEAN
#include "Chapt1.h"
#include <string.h>
#include <winuser.h>

int iii=0;

GrScreenResolution_t grRes;
GrScreenRefresh_t grFreq;
int grBuf,grZ,grDev;

int InStr(int start,const char *s,char symbol){
        int i,l=strlen(s);
        for(i=start;i<l;i++)
                if(symbol==s[i]) return i;
        return -1;
}

void StringToLowerCase(char *pstrKey) {
    if (pstrKey) {
        while (*pstrKey) {
            if ((*pstrKey>='A')&&(*pstrKey<='Z' )) {
                *pstrKey += 'a' - 'A';
            }
            pstrKey++;
        }
    }
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{WNDCLASS	wc;
 HWND		hWnd;
 MSG		Msg;

 wc.style         = CS_HREDRAW | CS_VREDRAW;
 wc.lpfnWndProc   = WindowProc;
 wc.cbClsExtra    = 0;
 wc.cbWndExtra    = 0;
 wc.hInstance     = hInstance;
 wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
 wc.hCursor       = LoadCursor(NULL, IDC_ARROW); //  
 wc.hbrBackground = NULL;                        //  
 wc.lpszMenuName  = NULL;                        //    
 wc.lpszClassName = "Glide";
 RegisterClass(&wc);
 hWnd = CreateWindow("Glide",
                     "Glide Test",
                     WS_POPUP,
                     0, 0,
                     GetSystemMetrics(SM_CXSCREEN),
                     GetSystemMetrics(SM_CYSCREEN),
                     NULL,
                     NULL,
                     hInstance,
                     NULL);
 if (hWnd == NULL)
  return 1;
 ShowWindow(hWnd, nCmdShow);

 char* pp[16]; int ppc=0;
 int i,l=strlen(lpCmdLine);
 if (l) {
    int ppi=-1;
    do {
        i=ppi+1;
        ppi=InStr(i,lpCmdLine,' ');
        if (ppi<0) ppi=l;
        if (ppi>i) {
            pp[ppc]=new char [ppi-i+1];
            strncpy(pp[ppc],lpCmdLine+i,ppi-i);
            pp[ppc][ppi-i]=0;
            ppc++;
        }
    } while (ppi<l);
 }
 grRes=GR_RESOLUTION_NONE;//640x480;
 grFreq=GR_REFRESH_NONE;
 grBuf=2; grZ=1; grDev=0;
 for (i=0;i<ppc;i++) {
	StringToLowerCase(pp[i]);
	if (!strcmp(pp[i],"320x200")) grRes=GR_RESOLUTION_320x200;
	if (!strcmp(pp[i],"320x240")) grRes=GR_RESOLUTION_320x240;
	if (!strcmp(pp[i],"400x256")) grRes=GR_RESOLUTION_400x256;
	if (!strcmp(pp[i],"400x300")) grRes=GR_RESOLUTION_400x300;
	if (!strcmp(pp[i],"512x256")) grRes=GR_RESOLUTION_512x256;
	if (!strcmp(pp[i],"512x384")) grRes=GR_RESOLUTION_512x384;
	if (!strcmp(pp[i],"640x200")) grRes=GR_RESOLUTION_640x200;
	if (!strcmp(pp[i],"640x350")) grRes=GR_RESOLUTION_640x350;
	if (!strcmp(pp[i],"640x400")) grRes=GR_RESOLUTION_640x400;
    if (!strcmp(pp[i],"640x480")) grRes=GR_RESOLUTION_640x480;
	if (!strcmp(pp[i],"800x600")) grRes=GR_RESOLUTION_800x600;
	if (!strcmp(pp[i],"856x480")) grRes=GR_RESOLUTION_856x480;
	if (!strcmp(pp[i],"960x720")) grRes=GR_RESOLUTION_960x720;
	if (!strcmp(pp[i],"1024x768")) grRes=GR_RESOLUTION_1024x768;
	if (!strcmp(pp[i],"1280x1024")) grRes=GR_RESOLUTION_1280x1024;
	if (!strcmp(pp[i],"1600x1200")) grRes=GR_RESOLUTION_1600x1200;
	if (!strcmp(pp[i],"1152x864")) grRes=16;
    if (!strcmp(pp[i],"1280x960")) grRes=17;
	if (!strcmp(pp[i],"1600x1024")) grRes=18;
	if (!strcmp(pp[i],"1792x1344")) grRes=19;
	if (!strcmp(pp[i],"1856x1392")) grRes=20;
	if (!strcmp(pp[i],"1920x1440")) grRes=21;
	if (!strcmp(pp[i],"2048x1536")) grRes=22;
	if (!strcmp(pp[i],"2048x2048")) grRes=23;
	if (!strcmp(pp[i],"60hz")) grFreq=GR_REFRESH_60Hz;
	if (!strcmp(pp[i],"70hz")) grFreq=GR_REFRESH_70Hz;
	if (!strcmp(pp[i],"72hz")) grFreq=GR_REFRESH_72Hz;
	if (!strcmp(pp[i],"75hz")) grFreq=GR_REFRESH_75Hz;
	if (!strcmp(pp[i],"80hz")) grFreq=GR_REFRESH_80Hz;
	if (!strcmp(pp[i],"85hz")) grFreq=GR_REFRESH_85Hz;
	if (!strcmp(pp[i],"90hz")) grFreq=GR_REFRESH_90Hz;
	if (!strcmp(pp[i],"100hz")) grFreq=GR_REFRESH_100Hz;
	if (!strcmp(pp[i],"120hz")) grFreq=GR_REFRESH_120Hz;
	if (!strcmp(pp[i],"simple")) grBuf=1;
	if (!strcmp(pp[i],"double")) grBuf=2;
	if (!strcmp(pp[i],"triple")) grBuf=3;
	if (!strcmp(pp[i],"nozbuffer")) grZ=0;
	if (!strcmp(pp[i],"zbuffer")) grZ=1;
	if (!strcmp(pp[i],"dev0")) grDev=0;
	if (!strcmp(pp[i],"dev1")) grDev=1;
	if (!strcmp(pp[i],"dev2")) grDev=2;
	if (!strcmp(pp[i],"dev3")) grDev=3;
 }
 if (grRes==GR_RESOLUTION_NONE)
	MessageBox(hWnd,"Unknown resolution. Please specify valid parameters in command line (see 3Dfx.txt for details)","Glide Test",0);
 Start(hWnd);
 //Sleep(1000);
 ShutDown();
 return 0;
}
//-----------------------------------------------------------------------------
//
LRESULT CALLBACK WindowProc(HWND hWnd,
                            UINT uMsg,
                            WPARAM wParam,
                            LPARAM lParam)
{
 return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
//---------------------------------------------------------------------------
// "" 3DFX
bool Start(HWND hWnd)
{//      3dfx
 if (!grGet(GR_NUM_BOARDS, sizeof(Num3Dfx), &Num3Dfx))
  return false;
 grGlideInit();
 grSstSelect(grDev);
 Context = grSstWinOpen((FxU32)hWnd,             //  
                        grRes,					 // 
                        grFreq,					 //  
                        GR_COLORFORMAT_ABGR,     //  
                        GR_ORIGIN_LOWER_LEFT,	 //   (0,0)
                        grBuf,                   //  
                        grZ);                      //    Z-
 if (!Context) MessageBox(hWnd,"Can't set video mode","Glide Test",0);
 return (Context);
}
//---------------------------------------------------------------------------
// 
void ShutDown()
{grSstWinClose(Context);
 grGlideShutdown();
}
//---------------------------------------------------------------------------
