#define WIN32_LEAN_AND_MEAN

#include "Chapt1.h"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#define GLIDE_DRAWING

int iii=0;

bool EnableZBuffer=false;
bool TripleBuffering=false;

float ScreenWidth=640;
float ScreenHeight=480;
GrScreenResolution_t grRes=GR_RESOLUTION_640x480;

WORD *FrontBuffer;
DWORD *FrontBuffer32;

const MaxCountGDI=256;
const MaxCountWMF=2048;

const float pi=3.14159265358979;

float scx=0.2;
float scy=0.2;
float xs=0;
float ys=0;
float ang=0;

bool AA=true;
int CircDetail=6;
float Gamma;

int WMFObjCount=0;

#define Color DWORD

struct VertexArray {
	int type;
	int count;
	float *x;
	float *y;
	bool *aa;
	Color c;
	float alpha;
};

struct GDIObject {
	WORD PenStyle;
	WORD PenWidth;
	DWORD PenColor;
	WORD BrushStyle;
	WORD BrushHatch;
	DWORD BrushColor;
	WORD ObjectType;
} ObjGDI[MaxCountGDI];

struct WMFObject {
	VertexArray Brush;
	VertexArray Pen;
	bool PenOnlyForCMode;
} ObjWMF[MaxCountWMF];

Color BkColor;
float MetaX1;
float MetaX2;
float MetaY1;
float MetaY2;

#define ViewX(X) (ScreenWidth/2+(X+xs)*scx)
#define ViewY(Y) (ScreenHeight/2+(Y+ys)*scy)

#define TypeConv(A) ((float)(short)(A))

#define PG_VTX_X(I) TypeConv(Buf[curadr+4+2*(I)])
#define PG_VTX_Y(I) TypeConv(Buf[curadr+5+2*(I)])
#define PG_VTX(I) PG_VTX_X(I),PG_VTX_Y(I)

#define CoordToVertex(V,X,Y) {V.x=ScreenWidth/2+(float(X)+xs)*scx*cos(ang)-(float(Y)+ys)*scy*sin(ang); V.y=ScreenHeight/2+(float(Y)+ys)*scy*cos(ang)+(float(X)+xs)*scx*sin(ang);}
//#define CoordToVertex(V,X,Y) {V.x=ViewX(X); V.y=ViewY(Y);}

float MonitorWeariness=0;
int GammaState=0;

float z0=0;

HDC ScreenDC;
HBITMAP VRam;
BYTE *VData;
BITMAPINFO VAttr;
HWND hWnd;

//char FileName[1024]="E:\\Alexandr\\ \\Metafile\\Metaedit\\WMF\\prntout2.wmf";
char FileName[1024]="C:\\Temp\\XP\\3Dfx\\WMF\\disk35.wmf";

BYTE BitmapHeader[54]={0x42,0x4D,0x36,0,0x24,0,0,0,0,0,0x36,0,0,0,0x28,0,0,0,0x20,3,0,0,0x58,2,0,0,1,0,0x18,0,0,0,0,0,0,0,0x24,0,0xC4,0xE,0,0,0xC4,0xE,0,0,0,0,0,0,0,0,0,0};
BYTE *BitmapData;

DWORD WINAPI Drawing(LPVOID);

DeleteVertexArray(VertexArray *va) {
	if (va->x) delete [] va->x;
	if (va->y) delete [] va->y;
	if (va->aa) delete [] va->aa;
}

CreateVertexArray(VertexArray *va,int type,int count,bool aa,Color c,float alpha) {
	DeleteVertexArray(va);
	va->type=type;
	va->count=count;
	va->x=new float [count];
	va->y=new float [count];
	if (aa) va->aa=new bool [count];
	va->c=c;
	va->alpha=alpha;
}

DrawVertexArray(VertexArray *va) {
	int i,n;
	if (va) {
		n=va->count;
		myVertex *vtx=new myVertex [n];
		for (i=0;i<n;i++) {
			vtx[i].a=va->alpha;
			CoordToVertex(vtx[i],va->x[i],va->y[i]);
		}
		#ifdef GLIDE_DRAWING
			switch (va->type) {
			case 4:
				if (AA) grEnable(GR_AA_ORDERED);
				grConstantColorValue(va->c);
				grDrawVertexArrayContiguous(GR_LINE_STRIP,n,vtx,sizeof(myVertex));
				break;
			case 5:
				grConstantColorValue(va->c);
				if ((va->aa)&&AA) {
					grEnable(GR_AA_ORDERED);
					for (i=0;i<n;i+=3) grAADrawTriangle(&(vtx[i]),&(vtx[i+1]),&(vtx[i+2]),va->aa[i],va->aa[i+1],va->aa[i+2]);
				} else {
					grDisable(GR_AA_ORDERED);
					grDrawVertexArrayContiguous(GR_TRIANGLES,n,vtx,sizeof(myVertex));
				}
				break;
			};
		#endif
		delete [] vtx;
	}
}

int InStr(int start,const char *s,char symbol) {
	int i,l=strlen(s);
	for (i=start;i<l;i++)
		if (symbol==s[i]) return i;
	return -1;
}

int InStr(int start,const char *s,const char *s2) {
	int i,j,l,l2;
	bool b;
	l=strlen(s);
	l2=strlen(s2);
	if ((l<l2)||(l2<=0)) return -1;
	for (i=0;i<=l-l2;i++)
		if (s[i]==s2[0]) {
			b=true;
			for (j=1;j<l2;j++) b=b&&(s[i+j]==s2[j]);
			if (b) return i;
		}
	return -1;
}

int sign(float x) {
	return (x==0)?0:(x/fabs(x));
}

int Orientation (float x1,float y1,float x2,float y2,float x3,float y3) {
	return sign((x2-x1)*(y3-y2)-(y2-y1)*(x3-x2));
}

#define MIN(a,b) ((a<b)?a:b)
#define MAX(a,b) ((a>b)?a:b)
#define IN_INTERVAL(a,a1,a2) ((a>=MIN(a1,a2))&&(a<=MAX(a1,a2)))

bool Peresec(float x1,float y1,float x2,float y2,float x3,float y3,float x4,float y4,float *x,float *y) {
	if (((x1==x3)&&(y1==y3))||((x1==x4)&&(y1==y4))) {*x=x1; *y=y1; return true;}
	if (((x2==x3)&&(y2==y3))||((x2==x4)&&(y2==y4))) {*x=x2; *y=y2; return true;}
	float f1=(y1-y2)*(x3-x4)-(x1-x2)*(y3-y4);
	float f2=(y3-y1)*(x1-x2)*(x3-x4)+x1*(y1-y2)*(x3-x4)-x3*(x1-x2)*(y3-y4);
	if (!f1) {
		*x=*y=1e32;
		if (f2) return false; else return IN_INTERVAL(x1,x3,x4)||IN_INTERVAL(x2,x3,x4);
	} else {
		*x=f2/f1;
		if (x1==x2) *y=(y4-y3)*(*x-x3)/(x4-x3)+y3; else *y=(y2-y1)*(*x-x1)/(x2-x1)+y1;
		return IN_INTERVAL(*x,x1,x2)&&IN_INTERVAL(*x,x3,x4)&&IN_INTERVAL(*y,y1,y2)&&IN_INTERVAL(*y,y3,y4);
	}
}

int NearestExist (int i,bool *src,int count) {
	for (int j=0;j<count;j++) if (src[(i+j)%count]) return (i+j)%count;
	return -1;
}

int PrevExist (int i,bool *src,int count) {
	for (int j=0;j<count;j++) if (src[(i+count-j)%count]) return (i+count-j)%count;
	return -1;
}

bool InTriangle(float x1,float y1,float x2,float y2,float x3,float y3,float x,float y) {
	float const eps=0;
	float v=(x-x1)*(y2-y1)-(y-y1)*(x2-x1);
	if (((x-x2)*(y3-y2)-(y-y2)*(x3-x2))*v>=-eps)
		if (((x-x3)*(y1-y3)-(y-y3)*(x1-x3))*v>=-eps)
			return true;
	return false;
}

bool LoadWMF (const char *FileName) {
	HANDLE hFile=CreateFile(FileName, GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

	DWORD ret;
	WORD *Buf;
	DWORD FileSize=GetFileSize(hFile,&ret);
	//if (FileSize>0) MessageBeep(0);		

	if ((FileSize>=20)&&(FileSize<=1024*1024*1024)&&(!ret)) {

		Buf=new WORD [(FileSize+1)/2];
		ReadFile(hFile,Buf,FileSize,&ret,NULL);
		CloseHandle(hFile);


		float cf=pi/(1<<CircDetail);

		int i,j,k,n;
		float f,a,b,x,y;

		myVertex vtxr[5];
		for (i=0;i<4;i++) {
			vtxr[i].a=255;
		}

		myVertex *vtx,*trvtx;
		myVertex curvtx={0,0,255};
		myVertex ourvtx={0,0,255};
		WORD PenStyle=0;
		WORD PenWidth=0;
		DWORD PenColor=0;
		WORD BrushStyle=0;
		WORD BrushHatch=0;
		DWORD BrushColor=0;
		float CurX=0,CurY=0;

		for (i=0;i<MaxCountGDI;i++) ObjGDI[i].ObjectType=0;

		int mfstart=0;
		if ((Buf[1]==0x9AC6)&&(Buf[0]==0xCDD7)) mfstart=11;
		int curadr=mfstart+9;
		int ouradr;
		DWORD RdSize;
		WORD RdType;
		WORD VertexCount;
		WORD PolygonCount;
		WORD *VtxCounts;

		WMFObjCount=0;
		BkColor=0x808080;

		bool *aa;

		while (curadr<FileSize/2-10) {
			RdSize=(Buf[curadr+1]<<16)|Buf[curadr];
			RdType=Buf[curadr+2];
			if (RdSize<3) RdSize=3;
			switch (RdType) {
			case 0x213:
				//CoordToVertex(ourvtx,Buf[curadr+4],Buf[curadr+3]);
				#ifdef DRAWING
//					grConstantColorValue(PenColor);
//					grDrawLine(&curvtx,&ourvtx);
				#endif
				/*ObjWMF[WMFObjCount].mfoAlpha=255;
				ObjWMF[WMFObjCount].mfoColor=PenColor;
				ObjWMF[WMFObjCount].mfoIfContured=true;
				ObjWMF[WMFObjCount].mfoIfNotContured=true;
				ObjWMF[WMFObjCount].mfoType=1;
				ObjWMF[WMFObjCount].mfoVtxCount=2;
				ObjWMF[WMFObjCount].mfoVtxX=new float [2];
				ObjWMF[WMFObjCount].mfoVtxY=new float [2];
				ObjWMF[WMFObjCount].mfoVtxX[0]=curvtx.x;
				ObjWMF[WMFObjCount].mfoVtxY[0]=curvtx.y;
				ObjWMF[WMFObjCount].mfoVtxX[1]=ourvtx.x;
				ObjWMF[WMFObjCount].mfoVtxY[1]=ourvtx.y;*/
				DeleteVertexArray(&(ObjWMF[WMFObjCount].Brush));
				CreateVertexArray(&(ObjWMF[WMFObjCount].Pen),4,2,false,PenColor,255);
				ObjWMF[WMFObjCount].Pen.x[0]=CurX;
				ObjWMF[WMFObjCount].Pen.y[0]=CurY;
				CurX=TypeConv(Buf[curadr+4]);
				CurY=TypeConv(Buf[curadr+3]);
				ObjWMF[WMFObjCount].Pen.x[1]=CurX;
				ObjWMF[WMFObjCount].Pen.y[1]=CurY;
				WMFObjCount++;
				//curvtx.x=ourvtx.x;
				//curvtx.y=ourvtx.y;
				break;
			case 0x214:
				//CoordToVertex(curvtx,Buf[curadr+4],Buf[curadr+3]);
				CurX=TypeConv(Buf[curadr+4]);
				CurY=TypeConv(Buf[curadr+3]);
				break;
			case 0x41B:
				CoordToVertex(vtxr[0],Buf[curadr+4],Buf[curadr+3]);
				CoordToVertex(vtxr[1],Buf[curadr+6],Buf[curadr+3]);
				CoordToVertex(vtxr[2],Buf[curadr+6],Buf[curadr+5]);
				CoordToVertex(vtxr[3],Buf[curadr+4],Buf[curadr+5]);
				DeleteVertexArray(&(ObjWMF[WMFObjCount].Brush));
				DeleteVertexArray(&(ObjWMF[WMFObjCount].Pen));
				if (!BrushStyle) {
					vtxr[4]=vtxr[0];
					#ifdef DRAWING
						//grDrawVertexArrayContiguous(GR_POLYGON,4,vtxr,sizeof(myVertex));
						//grAADrawTriangle(&(vtxr[0]),&(vtxr[1]),&(vtxr[2]),FXTRUE,FXTRUE,FXTRUE);
						//grAADrawTriangle(&(vtxr[2]),&(vtxr[3]),&(vtxr[4]),FXTRUE,FXTRUE,FXTRUE);
//						grConstantColorValue(BrushColor);
//						grDrawVertexArrayContiguous(GR_TRIANGLES,3,&(vtxr[0]),sizeof(myVertex));
//						grDrawVertexArrayContiguous(GR_TRIANGLES,3,&(vtxr[2]),sizeof(myVertex));
					#endif
					/*ObjWMF[WMFObjCount].mfoAlpha=255;
					ObjWMF[WMFObjCount].mfoColor=BrushColor;
					ObjWMF[WMFObjCount].mfoIfContured=false;
					ObjWMF[WMFObjCount].mfoIfNotContured=true;
					ObjWMF[WMFObjCount].mfoType=4;
					ObjWMF[WMFObjCount].mfoVtxCount=6;
					ObjWMF[WMFObjCount].mfoVtxX=new float [6];
					ObjWMF[WMFObjCount].mfoVtxY=new float [6];
					ObjWMF[WMFObjCount].mfoVtxX[0]=TypeConv(Buf[curadr+4]);
					ObjWMF[WMFObjCount].mfoVtxY[0]=TypeConv(Buf[curadr+3]);
					ObjWMF[WMFObjCount].mfoVtxX[1]=TypeConv(Buf[curadr+6]);
					ObjWMF[WMFObjCount].mfoVtxY[1]=TypeConv(Buf[curadr+3]);
					ObjWMF[WMFObjCount].mfoVtxX[2]=TypeConv(Buf[curadr+6]);
					ObjWMF[WMFObjCount].mfoVtxY[2]=TypeConv(Buf[curadr+5]);
					ObjWMF[WMFObjCount].mfoVtxX[3]=TypeConv(Buf[curadr+4]);
					ObjWMF[WMFObjCount].mfoVtxY[3]=TypeConv(Buf[curadr+3]);
					ObjWMF[WMFObjCount].mfoVtxX[4]=TypeConv(Buf[curadr+4]);
					ObjWMF[WMFObjCount].mfoVtxY[4]=TypeConv(Buf[curadr+5]);
					ObjWMF[WMFObjCount].mfoVtxX[5]=TypeConv(Buf[curadr+6]);
					ObjWMF[WMFObjCount].mfoVtxY[5]=TypeConv(Buf[curadr+5]);
					WMFObjCount++;*/
					CreateVertexArray(&(ObjWMF[WMFObjCount].Brush),5,6,PenStyle==5,BrushColor,255);
					ObjWMF[WMFObjCount].Brush.x[0]=TypeConv(Buf[curadr+4]);
					ObjWMF[WMFObjCount].Brush.y[0]=TypeConv(Buf[curadr+3]);
					ObjWMF[WMFObjCount].Brush.x[1]=TypeConv(Buf[curadr+6]);
					ObjWMF[WMFObjCount].Brush.y[1]=TypeConv(Buf[curadr+3]);
					ObjWMF[WMFObjCount].Brush.x[2]=TypeConv(Buf[curadr+6]);
					ObjWMF[WMFObjCount].Brush.y[2]=TypeConv(Buf[curadr+5]);
					ObjWMF[WMFObjCount].Brush.x[3]=TypeConv(Buf[curadr+4]);
					ObjWMF[WMFObjCount].Brush.y[3]=TypeConv(Buf[curadr+3]);
					ObjWMF[WMFObjCount].Brush.x[4]=TypeConv(Buf[curadr+4]);
					ObjWMF[WMFObjCount].Brush.y[4]=TypeConv(Buf[curadr+5]);
					ObjWMF[WMFObjCount].Brush.x[5]=TypeConv(Buf[curadr+6]);
					ObjWMF[WMFObjCount].Brush.y[5]=TypeConv(Buf[curadr+5]);
					if (ObjWMF[WMFObjCount].Brush.aa) {
						ObjWMF[WMFObjCount].Brush.aa[0]=true;
						ObjWMF[WMFObjCount].Brush.aa[1]=true;
						ObjWMF[WMFObjCount].Brush.aa[2]=false;
						ObjWMF[WMFObjCount].Brush.aa[3]=true;
						ObjWMF[WMFObjCount].Brush.aa[4]=true;
						ObjWMF[WMFObjCount].Brush.aa[5]=false;
					}
				}
				if (PenStyle!=5) {
					#ifdef DRAWING
						//grDrawLine(&(vtxr[0]),&(vtxr[1]));
						//grDrawLine(&(vtxr[1]),&(vtxr[2]));
						//grDrawLine(&(vtxr[2]),&(vtxr[3]));
						//grDrawLine(&(vtxr[3]),&(vtxr[0]));
//						grConstantColorValue(PenColor);
//						grDrawVertexArrayContiguous(GR_LINE_STRIP,5,vtxr,sizeof(myVertex));
					#endif
					/*ObjWMF[WMFObjCount].mfoAlpha=255;
					ObjWMF[WMFObjCount].mfoColor=PenColor;
					ObjWMF[WMFObjCount].mfoIfContured=true;
					ObjWMF[WMFObjCount].mfoIfNotContured=true;
					ObjWMF[WMFObjCount].mfoType=3;
					ObjWMF[WMFObjCount].mfoVtxCount=4;
					ObjWMF[WMFObjCount].mfoVtxX=new float [4];
					ObjWMF[WMFObjCount].mfoVtxY=new float [4];
					ObjWMF[WMFObjCount].mfoVtxX[0]=TypeConv(Buf[curadr+4]);
					ObjWMF[WMFObjCount].mfoVtxY[0]=TypeConv(Buf[curadr+3]);
					ObjWMF[WMFObjCount].mfoVtxX[1]=TypeConv(Buf[curadr+6]);
					ObjWMF[WMFObjCount].mfoVtxY[1]=TypeConv(Buf[curadr+3]);
					ObjWMF[WMFObjCount].mfoVtxX[2]=TypeConv(Buf[curadr+6]);
					ObjWMF[WMFObjCount].mfoVtxY[2]=TypeConv(Buf[curadr+5]);
					ObjWMF[WMFObjCount].mfoVtxX[3]=TypeConv(Buf[curadr+4]);
					ObjWMF[WMFObjCount].mfoVtxY[3]=TypeConv(Buf[curadr+5]);
					WMFObjCount++;*/
					CreateVertexArray(&(ObjWMF[WMFObjCount].Pen),4,5,false,PenColor,255);
					ObjWMF[WMFObjCount].Pen.x[0]=TypeConv(Buf[curadr+4]);
					ObjWMF[WMFObjCount].Pen.y[0]=TypeConv(Buf[curadr+3]);
					ObjWMF[WMFObjCount].Pen.x[1]=TypeConv(Buf[curadr+6]);
					ObjWMF[WMFObjCount].Pen.y[1]=TypeConv(Buf[curadr+3]);
					ObjWMF[WMFObjCount].Pen.x[2]=TypeConv(Buf[curadr+6]);
					ObjWMF[WMFObjCount].Pen.y[2]=TypeConv(Buf[curadr+5]);
					ObjWMF[WMFObjCount].Pen.x[3]=TypeConv(Buf[curadr+4]);
					ObjWMF[WMFObjCount].Pen.y[3]=TypeConv(Buf[curadr+5]);
					ObjWMF[WMFObjCount].Pen.x[4]=TypeConv(Buf[curadr+4]);
					ObjWMF[WMFObjCount].Pen.y[4]=TypeConv(Buf[curadr+3]);
				}
				WMFObjCount++;
				break;
			case 0x418:
				n=2<<CircDetail;
				DeleteVertexArray(&(ObjWMF[WMFObjCount].Brush));
				DeleteVertexArray(&(ObjWMF[WMFObjCount].Pen));
				vtx=new myVertex [n+2];
				x=(TypeConv(Buf[curadr+4])+TypeConv(Buf[curadr+6]))/2;
				y=(TypeConv(Buf[curadr+3])+TypeConv(Buf[curadr+5]))/2;
				a=fabs(TypeConv(Buf[curadr+4])-TypeConv(Buf[curadr+6]))/2;
				b=fabs(TypeConv(Buf[curadr+3])-TypeConv(Buf[curadr+5]))/2;
				for (i=0;i<=n;i++) {
					vtx[i].a=255;
					f=i*cf;
					CoordToVertex(vtx[i],x+a*cos(f),y+b*sin(f));
				}
				vtx[n+1]=vtx[0];
				if (!BrushStyle) {
					CreateVertexArray(&(ObjWMF[WMFObjCount].Brush),5,3*n,PenStyle==5,BrushColor,255);
					/*ObjWMF[WMFObjCount].mfoAlpha=255;
					ObjWMF[WMFObjCount].mfoColor=BrushColor;
					ObjWMF[WMFObjCount].mfoIfContured=false;
					ObjWMF[WMFObjCount].mfoIfNotContured=true;
					ObjWMF[WMFObjCount].mfoType=4;
					ObjWMF[WMFObjCount].mfoVtxCount=3*n;
					ObjWMF[WMFObjCount].mfoVtxX=new float [3*n];
					ObjWMF[WMFObjCount].mfoVtxY=new float [3*n];*/
					int trcnt=0; int jj; aa=ObjWMF[WMFObjCount].Brush.aa;
					for (j=0;j<CircDetail;j++) {
						jj=1<<j;
						for (i=0;i<jj;i++) {
							if ((j==CircDetail-1)&&aa) {
								aa[3*trcnt]=aa[3*trcnt+3]=true;
								aa[3*trcnt+1]=aa[3*trcnt+4]=true;
								aa[3*trcnt+2]=aa[3*trcnt+5]=false;
							}
							ObjWMF[WMFObjCount].Brush.x[3*trcnt]=x+a*cos(i*pi/jj);
							ObjWMF[WMFObjCount].Brush.y[3*trcnt]=y+b*sin(i*pi/jj);
							ObjWMF[WMFObjCount].Brush.x[3*trcnt+1]=x+a*cos((i+0.5)*pi/jj);
							ObjWMF[WMFObjCount].Brush.y[3*trcnt+1]=y+b*sin((i+0.5)*pi/jj);
							ObjWMF[WMFObjCount].Brush.x[3*trcnt+2]=x+a*cos((i+1)*pi/jj);
							ObjWMF[WMFObjCount].Brush.y[3*trcnt+2]=y+b*sin((i+1)*pi/jj);
							trcnt++;
							ObjWMF[WMFObjCount].Brush.x[3*trcnt]=x+a*cos(i*pi/jj);
							ObjWMF[WMFObjCount].Brush.y[3*trcnt]=y-b*sin(i*pi/jj);
							ObjWMF[WMFObjCount].Brush.x[3*trcnt+1]=x+a*cos((i+0.5)*pi/jj);
							ObjWMF[WMFObjCount].Brush.y[3*trcnt+1]=y-b*sin((i+0.5)*pi/jj);
							ObjWMF[WMFObjCount].Brush.x[3*trcnt+2]=x+a*cos((i+1)*pi/jj);
							ObjWMF[WMFObjCount].Brush.y[3*trcnt+2]=y-b*sin((i+1)*pi/jj);
							trcnt++;
						}
					}
					#ifdef DRAWING
//						grConstantColorValue(BrushColor);
						//grDrawVertexArrayContiguous(GR_POLYGON,n+1,vtx,sizeof(myVertex));
//						grDrawVertexArrayContiguous(GR_TRIANGLES,3*trcnt,trvtx,sizeof(myVertex));
					#endif

				}
				if (PenStyle!=5) {
					CreateVertexArray(&(ObjWMF[WMFObjCount].Pen),4,n+2,false,PenColor,255);
					/*ObjWMF[WMFObjCount].mfoAlpha=255;
					ObjWMF[WMFObjCount].mfoColor=PenColor;
					ObjWMF[WMFObjCount].mfoIfContured=true;
					ObjWMF[WMFObjCount].mfoIfNotContured=true;
					ObjWMF[WMFObjCount].mfoType=3;
					ObjWMF[WMFObjCount].mfoVtxCount=n+2;
					ObjWMF[WMFObjCount].mfoVtxX=new float [n+2];
					ObjWMF[WMFObjCount].mfoVtxY=new float [n+2];*/
					for (i=0;i<=n;i++) {
						f=i*cf;
						ObjWMF[WMFObjCount].Pen.x[i]=x+a*cos(f);
						ObjWMF[WMFObjCount].Pen.y[i]=y+b*sin(f);
					}
					ObjWMF[WMFObjCount].Pen.x[n+1]=x+a;
					ObjWMF[WMFObjCount].Pen.y[n+1]=y+0;
					#ifdef DRAWING
//						grConstantColorValue(PenColor);
//						grDrawVertexArrayContiguous(GR_LINE_STRIP,n+2,vtx,sizeof(myVertex));
					#endif
				}
				WMFObjCount++;
				delete [] vtx;
				break;
/*			case 0x61C:
				CoordToVertex(vtxr[0],Buf[curadr+6],Buf[curadr+5]);
				CoordToVertex(vtxr[1],Buf[curadr+8],Buf[curadr+5]);
				CoordToVertex(vtxr[2],Buf[curadr+8],Buf[curadr+7]);
				CoordToVertex(vtxr[3],Buf[curadr+6],Buf[curadr+7]);
				if (!BrushStyle) {
					vtxr[4]=vtxr[0];
					objz++;
					#ifdef DRAWING
						//grDrawVertexArrayContiguous(GR_POLYGON,4,vtxr,sizeof(myVertex));
						//grAADrawTriangle(&(vtxr[0]),&(vtxr[1]),&(vtxr[2]),FXTRUE,FXTRUE,FXTRUE);
						//grAADrawTriangle(&(vtxr[2]),&(vtxr[3]),&(vtxr[4]),FXTRUE,FXTRUE,FXTRUE);
						grConstantColorValue(BrushColor);
						grDrawVertexArrayContiguous(GR_TRIANGLES,3,&(vtxr[0]),sizeof(myVertex));
						grDrawVertexArrayContiguous(GR_TRIANGLES,3,&(vtxr[2]),sizeof(myVertex));
					#endif
				}
				if (PenStyle!=5) {
					#ifdef DRAWING
						//grDrawLine(&(vtxr[0]),&(vtxr[1]));
						//grDrawLine(&(vtxr[1]),&(vtxr[2]));
						//grDrawLine(&(vtxr[2]),&(vtxr[3]));
						//grDrawLine(&(vtxr[3]),&(vtxr[0]));
						grConstantColorValue(PenColor);
						grDrawVertexArrayContiguous(GR_LINE_STRIP,5,vtxr,sizeof(myVertex));
					#endif
				}
				break;*/
			case 0x324:
				VertexCount=Buf[curadr+3];
				DeleteVertexArray(&(ObjWMF[WMFObjCount].Brush));
				DeleteVertexArray(&(ObjWMF[WMFObjCount].Pen));
				if (!BrushStyle) {
					CreateVertexArray(&(ObjWMF[WMFObjCount].Brush),5,3*VertexCount,PenStyle==5,BrushColor,255);
					trvtx=new myVertex [3*VertexCount];
					for (i=0;i<3*VertexCount;i++) {
						trvtx[i].a=255;
					}
					int trcnt=0;
					aa=ObjWMF[WMFObjCount].Brush.aa;
					if (VertexCount>=3) {
						n=VertexCount;
						int i2,i3,ii,jj,kk,nn;
						bool *exvert;
						exvert=new bool [n];
						for (i=0;i<n;i++) exvert[i]=true;
						nn=n;
						for (j=0;(j<n)&&nn;j++) {
							i=NearestExist(0,exvert,n);
							ii=i;
							do {
								i2=NearestExist(i+1,exvert,n);
								i3=NearestExist(i2+1,exvert,n);
								k=Orientation(PG_VTX(i),PG_VTX(i2),PG_VTX(i3));
								if (!k) {
									exvert[i2]=false;
									i=i3; nn--;
								} else i=i2;
							} while ((exvert[i2])&&(i!=ii));
						}
						
						if (nn>=3) {
							k=NearestExist(i,exvert,n); f=PG_VTX_Y(k);
							for (j=1;j<n;j++)
								if ((exvert[j])&&(PG_VTX_Y(j)<f)) {k=j; f=PG_VTX_Y(j);}
							i=k; i2=NearestExist(i+1,exvert,n);
							ii=-1; i3=PrevExist(i-1,exvert,n);
							kk=Orientation(PG_VTX(i3),PG_VTX(i),PG_VTX(i2));
							if (!kk) kk=sign(PG_VTX_X(i2)-PG_VTX_X(i3));
							while ((nn>3)&&(i!=ii)) {
								ii=i;
								do {
									i2=NearestExist(i+1,exvert,n);
									i3=NearestExist(i2+1,exvert,n);
									k=Orientation(PG_VTX(i),PG_VTX(i2),PG_VTX(i3));
									if (k) {
										bool b=(k==kk);
										for (int j=0;j<n;j++) {
											if (exvert[j]&&(j!=i)&&(j!=i2)&&(j!=i3))
												if (InTriangle(PG_VTX(i),PG_VTX(i2),PG_VTX(i3),PG_VTX(j))) b=false;
										}
										//j=i3;
										//while (b&&(i!=j)) {
										//	jj=NearestExist(j+1,exvert,n);
										//	if (Peresec(PG_VTX(i),PG_VTX(i3),PG_VTX(j),PG_VTX(jj),&x,&y)) {
										//		if ((j!=i)&&(j!=i3)&&(jj!=i)&&(jj!=i3)) b=false;
										//	}
										//	j=jj;
										//}
										if (b) {
											ObjWMF[WMFObjCount].Brush.x[3*trcnt]=PG_VTX_X(i);
											ObjWMF[WMFObjCount].Brush.y[3*trcnt]=PG_VTX_Y(i);
											ObjWMF[WMFObjCount].Brush.x[3*trcnt+1]=PG_VTX_X(i2);
											ObjWMF[WMFObjCount].Brush.y[3*trcnt+1]=PG_VTX_Y(i2);
											ObjWMF[WMFObjCount].Brush.x[3*trcnt+2]=PG_VTX_X(i3);
											ObjWMF[WMFObjCount].Brush.y[3*trcnt+2]=PG_VTX_Y(i3);
											if (aa) {
												aa[3*trcnt]=((n+i-i2)%n==1)||((n+i2-i)%n==1)||true;
												aa[3*trcnt+1]=((n+i2-i3)%n==1)||((n+i3-i2)%n==1)||true;
												aa[3*trcnt+2]=((n+i3-i)%n==1)||((n+i-i3)%n==1)||false;
											}
											/*CoordToVertex(trvtx[3*trcnt],PG_VTX_X(i),PG_VTX_Y(i));
											CoordToVertex(trvtx[3*trcnt+1],PG_VTX_X(i2),PG_VTX_Y(i2));
											CoordToVertex(trvtx[3*trcnt+2],PG_VTX_X(i3),PG_VTX_Y(i3));*/
											trcnt++;
											exvert[i2]=false;
											i=i3; nn--;
										} else {
											i=i2;
										}
									} else {
										exvert[i2]=false;
										i=i3; nn--;
									}
								} while ((exvert[i2])&&(i!=ii));
							}
							if (nn=3) {
								i2=NearestExist(i+1,exvert,n);
								i3=NearestExist(i2+1,exvert,n);
								ObjWMF[WMFObjCount].Brush.x[3*trcnt]=PG_VTX_X(i);
								ObjWMF[WMFObjCount].Brush.y[3*trcnt]=PG_VTX_Y(i);
								ObjWMF[WMFObjCount].Brush.x[3*trcnt+1]=PG_VTX_X(i2);
								ObjWMF[WMFObjCount].Brush.y[3*trcnt+1]=PG_VTX_Y(i2);
								ObjWMF[WMFObjCount].Brush.x[3*trcnt+2]=PG_VTX_X(i3);
								ObjWMF[WMFObjCount].Brush.y[3*trcnt+2]=PG_VTX_Y(i3);
								if (aa) {
									aa[3*trcnt]=((n+i-i2)%n==1)||((n+i2-i)%n==1)||true;
									aa[3*trcnt+1]=((n+i2-i3)%n==1)||((n+i3-i2)%n==1)||true;
									aa[3*trcnt+2]=((n+i3-i)%n==1)||((n+i-i3)%n==1)||false;
								}
								/*CoordToVertex(trvtx[3*trcnt],PG_VTX_X(i),PG_VTX_Y(i));
								CoordToVertex(trvtx[3*trcnt+1],PG_VTX_X(i2),PG_VTX_Y(i2));
								CoordToVertex(trvtx[3*trcnt+2],PG_VTX_X(i3),PG_VTX_Y(i3));*/
								trcnt++;
							} else {
								myVertex *vtx0=new myVertex [VertexCount];

								delete [] vtx0;
							}
							delete [] exvert;
						} else trcnt=0;
						ObjWMF[WMFObjCount].Brush.count=3*trcnt;
						#ifdef DRAWING
//							grConstantColorValue(BrushColor);
							//grDrawVertexArrayContiguous(GR_POLYGON,VertexCount,vtx,sizeof(myVertex));
//							grDrawVertexArrayContiguous(GR_TRIANGLES,3*trcnt,trvtx,sizeof(myVertex));
						#endif
					}
					delete [] trvtx;
				}
				if (PenStyle!=5) {
					CreateVertexArray(&(ObjWMF[WMFObjCount].Pen),4,VertexCount+1,false,PenColor,255);
					/*ObjWMF[WMFObjCount].mfoAlpha=255;
					ObjWMF[WMFObjCount].mfoColor=PenColor;
					ObjWMF[WMFObjCount].mfoIfContured=true;
					ObjWMF[WMFObjCount].mfoIfNotContured=true;
					ObjWMF[WMFObjCount].mfoType=3;
					ObjWMF[WMFObjCount].mfoVtxCount=VertexCount+1;
					ObjWMF[WMFObjCount].mfoVtxX=new float [VertexCount+1];
					ObjWMF[WMFObjCount].mfoVtxY=new float [VertexCount+1];
					vtx=new myVertex [VertexCount+1];*/
					for (i=0;i<VertexCount;i++) {
						ObjWMF[WMFObjCount].Pen.x[i]=PG_VTX_X(i);
						ObjWMF[WMFObjCount].Pen.y[i]=PG_VTX_Y(i);
					}
					ObjWMF[WMFObjCount].Pen.x[VertexCount]=PG_VTX_X(0);
					ObjWMF[WMFObjCount].Pen.y[VertexCount]=PG_VTX_Y(0);
					#ifdef DRAWING
//						grConstantColorValue(PenColor);
//						grDrawVertexArrayContiguous(GR_LINE_STRIP,VertexCount+1,vtx,sizeof(myVertex));
					#endif
				}
				WMFObjCount++;
				//delete [] vtx;
				break;
			case 0x325:
				VertexCount=Buf[curadr+3];
				if (PenStyle!=5) {
					/*ObjWMF[WMFObjCount].mfoAlpha=255;
					ObjWMF[WMFObjCount].mfoColor=PenColor;
					ObjWMF[WMFObjCount].mfoIfContured=true;
					ObjWMF[WMFObjCount].mfoIfNotContured=true;
					ObjWMF[WMFObjCount].mfoType=3;
					ObjWMF[WMFObjCount].mfoVtxCount=VertexCount+1;
					ObjWMF[WMFObjCount].mfoVtxX=new float [VertexCount+1];
					ObjWMF[WMFObjCount].mfoVtxY=new float [VertexCount+1];
					vtx=new myVertex [VertexCount+1];
					for (i=0;i<VertexCount;i++) {
						ObjWMF[WMFObjCount].mfoVtxX[i]=PG_VTX_X(i);
						ObjWMF[WMFObjCount].mfoVtxY[i]=PG_VTX_Y(i);
					}
					ObjWMF[WMFObjCount].mfoVtxX[VertexCount]=ObjWMF[WMFObjCount].mfoVtxX[0];
					ObjWMF[WMFObjCount].mfoVtxY[VertexCount]=ObjWMF[WMFObjCount].mfoVtxY[0];*/
					DeleteVertexArray(&(ObjWMF[WMFObjCount].Brush));
					CreateVertexArray(&(ObjWMF[WMFObjCount].Pen),4,VertexCount,false,PenColor,255);
					for (i=0;i<VertexCount;i++) {
						ObjWMF[WMFObjCount].Pen.x[i]=PG_VTX_X(i);
						ObjWMF[WMFObjCount].Pen.y[i]=PG_VTX_Y(i);
					}
					WMFObjCount++;
					#ifdef DRAWING
//						grConstantColorValue(PenColor);
//						grDrawVertexArrayContiguous(GR_LINE_STRIP,VertexCount+1,vtx,sizeof(myVertex));
					#endif
				}

				/*vtx=new myVertex [VertexCount];
				for (i=0;i<VertexCount;i++) {
					vtx[i].a=255;
					CoordToVertex(vtx[i],Buf[curadr+4+2*i],Buf[curadr+5+2*i]);
				}
				#ifdef DRAWING
					//for (i=1;i<VertexCount;i++) {
						//grDrawLine(&(vtx[i-1]),&(vtx[i]));
					//}
					//grEnable(GR_AA_ORDERED);
					//grAADrawTriangle(&(vtx[0]),&(vtx[20]),&(vtx[40]),FXTRUE,FXTRUE,FXTRUE);
					//grDrawTriangle(&(vtx[0]),&(vtx[20]),&(vtx[40]));
					//grDrawLine(&(vtx[0]),&(vtx[1]));
					//grDrawVertexArray(GR_TRIANGLE_FAN,4,vtx);
					grConstantColorValue(PenColor);
					grDrawVertexArrayContiguous(GR_LINE_STRIP,VertexCount,vtx,sizeof(myVertex));
				#endif
				delete [] vtx;*/
				break;
/*			case 0x538:
				PolygonCount=Buf[curadr+3];
				VtxCounts=new WORD [PolygonCount];
				ouradr=curadr+4+PolygonCount;
				for (j=0;j<PolygonCount;j++) {
					VertexCount=Buf[curadr+4+j];
					vtx=new myVertex [VertexCount+1];
					for (i=0;i<VertexCount;i++) {
						vtx[i].a=255;
						CoordToVertex(vtx[i],Buf[ouradr+2*i],Buf[ouradr+1+2*i]);
					}
					vtx[VertexCount]=vtx[0];
					#ifdef DRAWING
						grConstantColorValue(PenColor);
						grDrawVertexArrayContiguous(GR_LINE_STRIP,VertexCount+1,vtx,sizeof(myVertex));
					#endif
					delete [] vtx;
					ouradr+=2*VertexCount;
				}
				delete [] VtxCounts;
				break;*/
			case 0x2FA:
				for (i=0;i<MaxCountGDI;i++)
					if (!ObjGDI[i].ObjectType) {
						ObjGDI[i].ObjectType=1;
						ObjGDI[i].PenStyle=Buf[curadr+3];
						ObjGDI[i].PenWidth=Buf[curadr+4];
						ObjGDI[i].PenColor=(Buf[curadr+7]<<16)|Buf[curadr+6];
						break;
					}
				break;
			case 0x2FC:
				for (i=0;i<MaxCountGDI;i++)
					if (!ObjGDI[i].ObjectType) {
						ObjGDI[i].ObjectType=2;
						ObjGDI[i].BrushStyle=Buf[curadr+3];
						ObjGDI[i].BrushHatch=Buf[curadr+6];
						ObjGDI[i].BrushColor=(Buf[curadr+5]<<16)|Buf[curadr+4];
						break;
					}
				break;
			case 0x2FB:
				for (i=0;i<MaxCountGDI;i++)
					if (!ObjGDI[i].ObjectType) {
						ObjGDI[i].ObjectType=3;
						break;
					}
				break;
			case 0x12D:
				j=Buf[curadr+3];
				switch (ObjGDI[j].ObjectType) {
				case 1:
					PenStyle=ObjGDI[j].PenStyle;
					PenWidth=ObjGDI[j].PenWidth;
					PenColor=ObjGDI[j].PenColor|0xFF000000;
					break;
				case 2:
					BrushStyle=ObjGDI[j].BrushStyle;
					BrushHatch=ObjGDI[j].BrushHatch;
					BrushColor=ObjGDI[j].BrushColor|0xFF000000;
					break;
				case 3:
					break;
				}
				break;
			case 0x1F0:
				ObjGDI[Buf[curadr+3]].ObjectType=0;
				break;
			case 0x201:
				BkColor=(Buf[curadr+4]<<16)|Buf[curadr+3];
				break;
			case 0x20C:
				scy=fabs(scy)*sign((short)Buf[curadr+3]);
				scx=fabs(scx)*sign((short)Buf[curadr+4]);
				break;
			}
			curadr+=RdSize;
		};
		return true;
	} else {
		return false;
	}
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

	if (strlen(lpCmdLine)) {
		strcpy(FileName,lpCmdLine+((lpCmdLine[0]==34)?1:0));
		if (FileName[strlen(FileName)-1]==34) FileName[strlen(FileName)-1]=0;
	}
	char CurDir[1024];
	strcpy(CurDir,GetCommandLine());
	CurDir[InStr(0,CurDir,"GlideWMF.exe")]=0;
	if (CurDir[0]==34)
		SetCurrentDirectory(CurDir+1);
	else
		SetCurrentDirectory(CurDir);

 WNDCLASS	wc;
 
 MSG		Msg;

 wc.style         = CS_HREDRAW | CS_VREDRAW;
 wc.lpfnWndProc   = WindowProc;
 wc.cbClsExtra    = 0;
 wc.cbWndExtra    = 0;
 wc.hInstance     = hInstance;
 wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
 wc.hCursor       = LoadCursor(NULL, IDC_ARROW); //  
 wc.hbrBackground = NULL;                        //  
 wc.lpszMenuName  = NULL;                        //    
 wc.lpszClassName = "Glide";
 RegisterClass(&wc);
 hWnd = CreateWindow("Glide",
                     "GlideWMF",
                     WS_POPUP,
                     0, 0,
                     GetSystemMetrics(SM_CXSCREEN),
                     GetSystemMetrics(SM_CYSCREEN),
                     NULL,
                     NULL,
                     hInstance,
                     NULL);
 if (hWnd == NULL)
  return 1;
 ShowWindow(hWnd, nCmdShow);
 /*while (GetMessage(&Msg, NULL, 0, 0))
 {TranslateMessage(&Msg);
  DispatchMessage(&Msg);
 }*/
 //Start(hWnd);
 return 0;
}
//-----------------------------------------------------------------------------
//
LRESULT CALLBACK WindowProc(HWND hWnd,
                            UINT uMsg,
                            WPARAM wParam,
                            LPARAM lParam)
{switch (uMsg)
 {case WM_ACTIVATE:
	if (LOWORD(wParam)==WA_ACTIVE) {
		if (!Start(hWnd))
			return -1;
	};
	return 0;
  case WM_DESTROY:
   ShutDown();
   PostQuitMessage(0);
   return 0;
  case WM_SETCURSOR:
   SetCursor(FALSE);
   return TRUE;
  case WM_KEYUP:
   if (wParam == VK_ESCAPE)
    DestroyWindow(hWnd);
   return 0;
 }
 return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
//---------------------------------------------------------------------------
// "" 3DFX
bool Start(HWND hWnd)
{//      3dfx
	if (!grGet(GR_NUM_BOARDS, sizeof(Num3Dfx), &Num3Dfx)) return false;
	char ScrMode[16];
	char Buffering[16];
	int BoardNumber=0;
	FILE *devcfg=fopen("GlideDevice.cfg","rt");
	if (devcfg) {
		fscanf(devcfg,"%i",&BoardNumber);
		fscanf(devcfg,"%s",ScrMode);
		fscanf(devcfg,"%s",Buffering);
		fclose(devcfg);	
		if (strlen(ScrMode)>=7) {
			if (!strcmp(ScrMode,"320x240")) {grRes=GR_RESOLUTION_320x240; ScreenWidth=320; ScreenHeight=240;}
			if (!strcmp(ScrMode,"400x300")) {grRes=GR_RESOLUTION_400x300; ScreenWidth=400; ScreenHeight=300;}
			if (!strcmp(ScrMode,"512x384")) {grRes=GR_RESOLUTION_512x384; ScreenWidth=512; ScreenHeight=384;}
			if (!strcmp(ScrMode,"640x480")) {grRes=GR_RESOLUTION_640x480; ScreenWidth=640; ScreenHeight=480;}
			if (!strcmp(ScrMode,"800x600")) {grRes=GR_RESOLUTION_800x600; ScreenWidth=800; ScreenHeight=600;}
			if (!strcmp(ScrMode,"960x720")) {grRes=GR_RESOLUTION_960x720; ScreenWidth=960; ScreenHeight=720;}
			if (!strcmp(ScrMode,"1024x768")) {grRes=GR_RESOLUTION_1024x768; ScreenWidth=1024; ScreenHeight=768;}
			if (!strcmp(ScrMode,"1600x1200")) {grRes=GR_RESOLUTION_1600x1200; ScreenWidth=1600; ScreenHeight=1200;}
			if (!strcmp(ScrMode,"320x200")) {grRes=GR_RESOLUTION_320x200; ScreenWidth=320; ScreenHeight=200;}
			if (!strcmp(ScrMode,"400x256")) {grRes=GR_RESOLUTION_400x256; ScreenWidth=400; ScreenHeight=256;}
			if (!strcmp(ScrMode,"512x256")) {grRes=GR_RESOLUTION_512x256; ScreenWidth=512; ScreenHeight=256;}
			if (!strcmp(ScrMode,"640x200")) {grRes=GR_RESOLUTION_640x200; ScreenWidth=640; ScreenHeight=200;}
			if (!strcmp(ScrMode,"640x350")) {grRes=GR_RESOLUTION_640x350; ScreenWidth=640; ScreenHeight=350;}
			if (!strcmp(ScrMode,"640x400")) {grRes=GR_RESOLUTION_640x400; ScreenWidth=640; ScreenHeight=400;}
			if (!strcmp(ScrMode,"856x480")) {grRes=GR_RESOLUTION_856x480; ScreenWidth=856; ScreenHeight=480;}
			if (!strcmp(ScrMode,"1280x1024")) {grRes=GR_RESOLUTION_1280x1024; ScreenWidth=1280; ScreenHeight=1024;}
			if (!strcmp(ScrMode,"1152x864")) {grRes=16; ScreenWidth=1152; ScreenHeight=864;}
		}
	}
	if (!LoadWMF(FileName)) {
		MessageBox(hWnd,"Can't load metafile","Glide WMF",MB_ICONERROR);
		return false;
	}
	if ((BoardNumber<0)||(BoardNumber>Num3Dfx-1)) {
		MessageBox(hWnd,"Wrong device number (GlideDevice.cfg)","Glide WMF",MB_ICONERROR);
		return false;
	}
	TripleBuffering=(Buffering[0]=='T')||(Buffering[0]=='t');
	#ifdef GLIDE_DRAWING
		//ScreenDC=CreateDC("DISPLAY","","",0);
		//if (ScreenDC) Sleep(5000);
		//VRam=CreateCompatibleBitmap(ScreenDC,800,600);
		//VRam=CreateDIBSection(ScreenDC,&VAttr,DIB_RGB_COLORS,(VOID**)(VData),NULL,0);
		//VData=new BYTE [4*1024*1024];
		//if (VData) Sleep(5000);
		//VData=(unsigned char*)0xE8000000;
		//VData[0];
		//if (GetDIBits(ScreenDC,VRam,0,600,0,&VAttr,0)) {
		//	Sleep(5000);
		//}
		//if (VAttr.bmiHeader.biWidth==800) Sleep(5000); 
		/*COLORREF color;
		for (int y=0; y<240; y++)
			for (int x=0; x<320; x++) {
				color=GetPixel(ScreenDC,x,y);
				VData[(320*y+x)*4]=GetBValue(color);
				VData[(320*y+x)*4+1]=GetGValue(color);
				VData[(320*y+x)*4+2]=GetRValue(color);
				VData[(320*y+x)*4+3]=0;
			}*/
		grGlideInit();
		grSstSelect(BoardNumber);
		//grRes=16;
		//ScreenWidth=1152; ScreenHeight=864;
		Context = grSstWinOpen((FxU32)GetForegroundWindow(),             //  
								grRes,					// 
								GR_REFRESH_85Hz,        //  
								GR_COLORFORMAT_ABGR,    //  
								GR_ORIGIN_UPPER_LEFT,	//   (0,0)
								TripleBuffering?3:2,    //  
								EnableZBuffer?1:0);     //    Z-
		if (Context == NULL) {
			MessageBox(hWnd,"Can't set video mode (GlideDevice.cfg)","Glide WMF",MB_ICONERROR);
			return false;
		}

		grColorCombine( GR_COMBINE_FUNCTION_SCALE_OTHER,
							GR_COMBINE_FACTOR_ONE,
							GR_COMBINE_LOCAL_CONSTANT,
							GR_COMBINE_OTHER_CONSTANT,
							FXFALSE );

			//   -
		 grAlphaCombine(GR_COMBINE_FUNCTION_BLEND, //   -
						GR_COMBINE_FACTOR_ONE,           // 
						GR_COMBINE_LOCAL_ITERATED,       //
						GR_COMBINE_OTHER_ITERATED,       //
						FXFALSE);                        //   -

		 grAlphaBlendFunction(GR_BLEND_SRC_ALPHA,
							  GR_BLEND_ONE_MINUS_SRC_ALPHA,
							  GR_BLEND_ZERO,
							  GR_BLEND_ZERO);
		
		//grLfbConstantAlpha(255);
		//grLfbWriteRegion(GR_BUFFER_FRONTBUFFER,0,0,GR_LFBWRITEMODE_888,320,240,FXTRUE,4*320,VData);
		
		//Sleep(5000);
	#endif
	if (!Drawing(0)) return false;
	return true;
}

// 
void ShutDown()
{
	#ifdef GLIDE_DRAWING
		grSstWinClose(Context);
		grGlideShutdown();
	#endif
}

float SetGamma(float gamma) {
	float gm=gamma;
	if (GammaState!=1) {
		if (gm<1./8) gm=1./8;
		if (gm>8) gm=8;
	}
	FxU32 *r,*g,*b;
	FxI32 nEntries;
	grGet(GR_GAMMA_TABLE_ENTRIES,4,&nEntries);
	r=new FxU32 [nEntries];
	g=new FxU32 [nEntries];
	b=new FxU32 [nEntries];
	float f,f0,f1;
	int i;
	f0=MonitorWeariness;
	f1=1/gm;
	for (i=0; i<nEntries; i++) {
		f=i/(nEntries-1.);
		r[i]=g[i]=b[i]=255*(f0+(1-f0)*pow(f,f1));
	}
	r[0]=g[0]=b[0]=0;
	#ifdef GLIDE_DRAWING
		grLoadGammaTable(nEntries,r,g,b);
	#endif
	if (GammaState==2) {
		DWORD dw=4*nEntries;
		BYTE *gtv;
		gtv=new BYTE [dw];
		HANDLE hGammaTable;
		hGammaTable=CreateFile("GammaTable.dat",GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
		if (hGammaTable!=INVALID_HANDLE_VALUE) {
			for (i=0;i<nEntries;i++) {
				gtv[4*i]=r[i];
				gtv[4*i+1]=g[i];
				gtv[4*i+2]=b[i];
				gtv[4*i+3]=0;
			}
			WriteFile(hGammaTable,gtv,dw,&dw,0);
		}
		CloseHandle(hGammaTable);
		/*FILE *gt=fopen("GammaTable.dat","wt");
		if (gt) {
			fprintf(gt);
			fclose(gt);
		}*/
		delete [] gtv;
		//To gammatable.dat
		GammaState=0;
	}
	delete [] r;
	delete [] g;
	delete [] b;
	//guGammaCorrectionRGB(gm,gm,gm);
	return gm;
}

float DefaultGamma() {
	float gm;
	FILE *fg=fopen("GlideColors.cfg","rt");
	if (fg) {
		fscanf(fg,"%f",&gm);
		fscanf(fg,"%f",&MonitorWeariness);
		fclose(fg);
	} else gm=1.2;
	if (MonitorWeariness<0) MonitorWeariness=0;
	if (MonitorWeariness>0.5) MonitorWeariness=0.5;
	return SetGamma(gm);
}

DWORD WINAPI Drawing(LPVOID)
{

	//SetForegroundWindow(hWnd);

	//Sleep(1000);

	//DestroyWindow(hWnd);

	DWORD BeginTime=GetTickCount();
	DWORD Frames=0;

	DWORD t=GetTickCount();
	DWORD dt=0,dw;

	if (true) {

		#ifdef GLIDE_DRAWING

			grColorCombine( GR_COMBINE_FUNCTION_SCALE_OTHER,
							GR_COMBINE_FACTOR_ONE,
							GR_COMBINE_LOCAL_CONSTANT,
							GR_COMBINE_OTHER_CONSTANT,
							FXFALSE );

				//   -
			 grAlphaCombine(GR_COMBINE_FUNCTION_BLEND, //   -
							GR_COMBINE_FACTOR_ONE,           // 
							GR_COMBINE_LOCAL_ITERATED,       //
							GR_COMBINE_OTHER_ITERATED,       //
							FXFALSE);                        //   -

			 grAlphaBlendFunction(GR_BLEND_SRC_ALPHA,
								  GR_BLEND_ONE_MINUS_SRC_ALPHA,
								  GR_BLEND_ZERO,
								  GR_BLEND_ZERO);

			 //  Z-
			if (EnableZBuffer) {
				//grDepthBufferMode(GR_DEPTHBUFFER_ZBUFFER);      //  Z-
				//grDepthBufferFunction(GR_CMP_GREATER);
				//grDepthMask(FXTRUE);
			}
 
			grCoordinateSpace(GR_WINDOW_COORDS);
			//     
			grVertexLayout(GR_PARAM_XY, 0, GR_PARAM_ENABLE);	//   X, Y
			grVertexLayout(GR_PARAM_A, 8, GR_PARAM_ENABLE);	// -

			 //  
			grBufferClear( 0, 0, 0 );

		#endif

		Gamma=DefaultGamma();
		
		POINT mcp;

		do {

			#ifdef GLIDE_DRAWING
				grBufferClear( (GammaState==1)?0x000000:BkColor, 0, 0 );
				if (AA) grEnable(GR_AA_ORDERED); else grDisable(GR_AA_ORDERED);   // -
				myVertex vtx1={0,0,255};
				myVertex vtx2={1024,0,255};
				myVertex vtx3={1024,768,255};
				myVertex vtx4={0,768,255};
				//grDrawTriangle(&vtx1,&vtx2,&vtx3);
				//grDrawTriangle(&vtx3,&vtx4,&vtx1);
				//grConstantColorValue(0xFFFFFFFF);
			#endif

			t+=(dt=GetTickCount()-t*1.);

			float step=1;
			float f;
			int i,j,k;

			if (dt<8) step=dt/8.;
			if (dt>40) step=dt/40.;

			/*if (Frames%10==0) {
				SetActiveWindow(hWnd);
				SetForegroundWindow(hWnd);
				Sleep(100);
			}*/

			if (Frames%1==0) {
				if (1&GetAsyncKeyState(80)) {
					FxI32 bpc[4];
					if (grGet(GR_BITS_RGBA,16,bpc)==16) {
						BitmapHeader[18]=((WORD)ScreenWidth)%256;
						BitmapHeader[19]=((WORD)ScreenWidth)/256;
						BitmapHeader[22]=((WORD)ScreenHeight)%256;
						BitmapHeader[23]=((WORD)ScreenHeight)/256;
						BitmapData=new BYTE [3*ScreenWidth*ScreenHeight];
						if (bpc[0]+bpc[1]+bpc[2]==16) {
							FrontBuffer=new WORD [ScreenWidth*ScreenHeight];
							grLfbReadRegion(GR_BUFFER_FRONTBUFFER,0,0,ScreenWidth,ScreenHeight,2*ScreenWidth,FrontBuffer);
							k=0; WORD FBValue;
							for (j=0;j<ScreenHeight;j++)
								for (i=0;i<ScreenWidth;i++) {
									FBValue=FrontBuffer[((int)ScreenHeight-1-j)*(int)ScreenWidth+i];
									BitmapData[3*k]=(FBValue&0x001F)<<3;
									BitmapData[3*k+1]=(FBValue&0x07E0)>>3;
									BitmapData[3*k+2]=(FBValue&0xF800)>>8;
									k++;
								}
						} else {
							FrontBuffer32=new DWORD [ScreenWidth*ScreenHeight];
							grLfbReadRegion(GR_BUFFER_FRONTBUFFER,0,0,ScreenWidth,ScreenHeight,4*ScreenWidth,FrontBuffer32);
							k=0; DWORD FBValue;
							for (j=0;j<ScreenHeight;j++)
								for (i=0;i<ScreenWidth;i++) {
									FBValue=FrontBuffer32[((int)ScreenHeight-1-j)*(int)ScreenWidth+i];
									BitmapData[3*k]=(FBValue&0xFF);
									BitmapData[3*k+1]=(FBValue&0xFF00)>>8;
									BitmapData[3*k+2]=(FBValue&0xFF0000)>>16;
									k++;
								}
						}
						HANDLE hBmpFile;
						hBmpFile=CreateFile("Photo.bmp",GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
						if (hBmpFile!=INVALID_HANDLE_VALUE) {
							dw=54;
							WriteFile(hBmpFile,BitmapHeader,dw,&dw,0);
							dw=3*ScreenWidth*ScreenHeight;
							WriteFile(hBmpFile,BitmapData,dw,&dw,0);
						}
						CloseHandle(hBmpFile);
						delete [] BitmapData;
						delete [] FrontBuffer;
					}
				}
				if (1&GetAsyncKeyState(65)) AA=!AA;
				if (1&GetAsyncKeyState(77)) {
					if (GetAsyncKeyState(18)) scx=-scx; else scy=-scy;
				}
				f=pow(1.01,step);
				if (GetAsyncKeyState(107)||GetAsyncKeyState(1)) {scx*=f; scy*=f;}
				if (GetAsyncKeyState(109)||GetAsyncKeyState(2)) {scx/=f; scy/=f;}
				if (fabs(scx)>1) scx=sign(scx);
				if (fabs(scy)>1) scy=sign(scy);
				if (fabs(scx)<0.01) scx=0.01*sign(scx);
				if (fabs(scy)<0.01) scy=0.01*sign(scy);
				/*if (GetAsyncKeyState(37)) xs+=10;
				if (GetAsyncKeyState(39)) xs-=10;
				if (GetAsyncKeyState(38)) ys+=10;
				if (GetAsyncKeyState(40)) ys-=10;*/
				if (GetAsyncKeyState(100)) ang+=0.01*step;
				if (GetAsyncKeyState(101)) ang=0;
				if (GetAsyncKeyState(102)) ang-=0.01*step;
				if (GetAsyncKeyState(71)) {
					if (!GammaState) {
						GammaState=1;
						SetGamma(1e-10);
					}
				} else {
					if (GammaState==1) {
						GammaState=2;
						SetGamma(Gamma);
					}
					if (1&GetAsyncKeyState(36)) Gamma=DefaultGamma();
					if (1&GetAsyncKeyState(35)) {
						FILE *fg=fopen("GlideColors.cfg","wt");
						if (fg) {
							fprintf(fg,"%f\n",Gamma);
							fprintf(fg,"%f",MonitorWeariness);
							fclose(fg);
						}
					}
					f=1;
					if (GetAsyncKeyState(33)) f*=pow(1.01,step);
					if (GetAsyncKeyState(34)) f/=pow(1.01,step);
					if (f!=1) Gamma=SetGamma(Gamma*f);
				}
				GetCursorPos(&mcp);
				xs=10*(ScreenWidth/2-mcp.x); ys=10*(ScreenHeight/2-mcp.y);
				//SetCursorPos(ScreenWidth/2,ScreenHeight/2);
			
				
			}

			//if ((hFile)&&(hFile!=INVALID_HANDLE_VALUE)) MessageBeep(0);

			/*for (i=0;i<WMFObjCount;i++) {
				n=ObjWMF[i].mfoVtxCount;
				switch (ObjWMF[i].mfoType) {

				case 3:
					vtx=new myVertex [n];
					for (j=0;j<n;j++) {
						CoordToVertex(vtx[j],ObjWMF[i].mfoVtxX[j],ObjWMF[i].mfoVtxY[j]);
						vtx[j].a=255;
					}
					#ifdef DRAWING
						grConstantColorValue(ObjWMF[i].mfoColor);
						grDrawVertexArrayContiguous(GR_LINE_STRIP,n,vtx,sizeof(myVertex));
					#endif
					delete [] vtx;
					break;					
				case 4:
					trvtx=new myVertex [n];
					for (j=0;j<n;j++) {
						CoordToVertex(trvtx[j],ObjWMF[i].mfoVtxX[j],ObjWMF[i].mfoVtxY[j]);
						trvtx[j].a=255;
					}
					#ifdef DRAWING
						grConstantColorValue(ObjWMF[i].mfoColor);
						grDrawVertexArrayContiguous(GR_TRIANGLES,n,trvtx,sizeof(myVertex));
					#endif
					delete [] trvtx;
				}
			}*/

			for (i=0;i<WMFObjCount;i++) {
				DrawVertexArray(&(ObjWMF[i].Brush));
				DrawVertexArray(&(ObjWMF[i].Pen));
			}

			#ifdef GLIDE_DRAWING
				grBufferSwap(1);
			#endif
			Frames++;
		} while (!GetAsyncKeyState(27)&&!GetAsyncKeyState(91)&&!GetAsyncKeyState(92)&&!GetAsyncKeyState(18));

	}

	ShutDown();

	DWORD EndTime=GetTickCount();

	FILE *fps=fopen("GlideWMF.FPS","wt");
	#ifdef GLIDE_DRAWING
		fprintf(fps,"%s\n",grGetString(GR_HARDWARE));
	#endif
	fprintf(fps,"%s\n",FileName);
	fprintf(fps,"%i FPS",1000*Frames/(EndTime-BeginTime));
	fclose(fps);

	DestroyWindow(hWnd);
	PostQuitMessage(0);
	return true;
}